#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h> // can't use Utils.hh
#include <unistd.h>
#include "PathConfig.hh"

#define client_path ClientBinInstallPath

#define XMVI(bpp, colormodel) XMatchVisualInfo(dp, screen, bpp, colormodel, &vinfo_return)

int main(char **argv, int argc)
{
  printf("Wormz\n");
  Display * dp;
  if ((dp = XOpenDisplay (0)) == 0) {
    printf ("Could not open display\n");
    exit(1);
  }
  XSetCloseDownMode (dp, DestroyAll);
  int screen = DefaultScreen (dp);
  XVisualInfo vinfo_return;
  int depth=-1;

  if (XMVI(8, PseudoColor)) {
    depth = 8;
  } else
  if (XMVI(32, TrueColor)) {
   // depth = 32;
  } else
  if (XMVI(24, TrueColor)) {
    depth = 24;
  } else
  if (XMVI(16, TrueColor)) {
    depth = 16;
  } else
  if (XMVI(15, TrueColor)) {
    // depth = 15;
  } else
  if (XMVI(8, GrayScale)) {
    // depth = 8;
  }
  XCloseDisplay(dp);
  if (depth>0) {
    printf("Using %ibpp\n", depth);
    char depth_s[100];
    sprintf(depth_s, "%s%i", client_path, depth);
    char * arg1 = (argc >= 1 ? argv[1] : 0);
    char * arg2 = (argc >= 2 ? argv[2] : 0);
    char * arg3 = (argc >= 3 ? argv[3] : 0);
    execl(depth_s, depth_s, arg1, arg2, arg3, 0); // should be enough
    perror("can't exec");
    exit(-3);     
  } else {
    printf("Unsupported depth of display!\n");
    exit(-2);
  }
}

